<template>
	<div class="content__leftAnalitika">
		<div class="pc-dop">
			<p class="text-titlePc">
				<router-link :to="route('tickets')">
					<svg>
						<use xlink:href="/img/sprite.svg#long-arrow-pointing-to-the-right"/>
					</svg>
					{{ $t('ui.back') }}
				</router-link>
				{{ $t('tickets.show.title') }} "{{ ticket.subject }}"
			</p>
			<div class="messages" ref="chat">
				<div class="message" v-for="message in ticket.messages" :class="messageClass(message)">
					<div class="message__text">
						{{ message.message }}
					</div>
					<div class="message__footer">
						<a href="#" class="message__link" @click.prevent="editMessage(message)">{{ $t('tickets.show.edit') }}</a> |
						<router-link class="message__link" :to="route('users_edit', {
							id: message.user_id
						})">
							{{ message.user.login }}
						</router-link> |
						{{ message.created_at | formatDate }}
					</div>
				</div>
			</div>
			<form class="message-form" @submit.prevent="save">
				<textarea name="message" id="form_message" v-model="form.message"></textarea>
				<svg class="delete" @click="cancelEdit()" v-if="form.message_id">
					<use xlink:href="/img/sprite.svg#cancel-button"/>
				</svg>
				<button type="submit" class="save" >{{ submitText }}</button>
			</form>
		</div>
	</div>
</template>

<script>
import route from "../mixins/route";
import {mapGetters} from "vuex";
import dayjs from "dayjs";

export default {
	name: "TicketShow",
	mixins: [route],
	props: {
		id: {
			type: [Number, String],
			required: true
		}
	},
	data() {
		return {
			ticket: {
				messages: []
			},
			form: {
				ticket_id: this.id,
				message_id: undefined,
				message: ''
			}
		}
	},
	computed: {
		...mapGetters([
			'axios'
		]),
		submitText(){
			return this.form.message_id ? this.$t('tickets.show.save') : this.$t('tickets.show.send')
		}
	},
	filters: {
		formatDate(value) {
			return dayjs(value).format('YYYY.MM.DD HH:mm');
		}
	},
	methods: {
		load() {
			this.axios
				.get(`tickets/${this.id}`)
				.then(resp => resp.data)
				.then(ticket => this.ticket = ticket)
				.then(() => {
					this.$refs.chat.scrollTop = this.$refs.chat.scrollHeight;
				})
			;
		},
		messageClass(message) {
			return {
				'message--inbox': this.ticket.user_id !== message.user_id
			}
		},
		cancelEdit(){
			this.form.message = '';
			this.form.message_id = null;
		},
		editMessage(message){
			this.form.message = message.message;
			this.form.message_id = message.id;
		},
		save() {
			this.axios
				.post(`/tickets/message`, this.form)
				.then(resp => resp.data)
				.then(data => {
					if(data.status === 'success'){
						let messageIndex = this.ticket.messages.findIndex((message) => message.id === data.ticket_message.id);
						if(messageIndex !== -1){
							this.ticket.messages.splice(messageIndex, 1, data.ticket_message);
							this.$swal(this.$t('ui.success'), data.message, 'success');
						}else{
							this.ticket.messages.push(data.ticket_message);
							this.$swal(this.$t('ui.success'), data.message, 'success').then(() => {
								this.$refs.chat.scrollTop = this.$refs.chat.scrollHeight;
							});
						}
						this.form.message_id = undefined;
						this.form.message = '';
					}
				})
			;
		}
	},
	mounted() {
		this.load();
	}
}
</script>

<style scoped lang="scss">
.messages {
	display: flex;
	align-items: flex-end;
	flex-direction: column;
	max-height: 1000px;
	overflow-y: auto;
	padding: 0 1em;
}

.message {
	background-image: linear-gradient(to top, rgba(97, 97, 97, 0.04) 0%, rgba(255, 255, 255, 0.1) 100%);
	border-radius: 10px;
	background-color: #ffffff;
	box-shadow: 0 30px 50px rgba(90, 90, 90, 0.1);
	padding: 42px;
	width: 80%;
	margin-bottom: 40px;

	color: #383838;
	font-size: 14px;
	font-weight: 400;
	line-height: 15px;

	&--inbox{
		align-self: flex-start;
	}

	&__text{
		margin-bottom: 1rem;

		white-space: pre-line;
	}
	&__link{
		color: #2b5ede;
		text-decoration: none;
		transition-duration: 500ms;
		transition-property: color;

		&:hover{
			color: #1941a3;
		}
	}
	&__footer{
		text-align: right;
	}

	&-form{
		width: calc(100% - 100px);
		padding: 41px 50px 41px 50px;
		border-radius: 10px;
		background-color: #ffffff;
		display: flex;
		align-items: center;

		textarea{
			flex: 1;
			border-radius: 8px;
			background-color: #f5f5f5;
			resize: vertical;
			padding: 15px;
			color: #383838;
			font-size: 14px;
			font-weight: 400;
			line-height: 15px;
			border: none;
			box-shadow: none;
			outline: none;
		}
		.delete{
			width: 22px;
			height: 22px;
			fill: #ee4949;
			cursor: pointer;
			transition-duration: 500ms;
			transition-property: fill;
			margin-left: 20px;
		}
		.save{
			height: 37px;
			margin-left: 20px;
		}
	}
}
@media(max-width: 616px) {
	.messages{
		padding: 0;
	}
	.message{
		padding: 20px 30px;
		&-form{
			flex-wrap: wrap;
			justify-content: center;
			width: calc(100% - 60px);
			padding: 20px 30px;
			textarea{
				flex-basis: 100%;
				margin-bottom: 20px;
			}
		}
	}
}
</style>
